/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SortRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SortRequest{}

// SortRequest struct for SortRequest
type SortRequest struct {
	Source *string `json:"source,omitempty"`
	//
	Rules []SortRuleRequest `json:"rules,omitempty"`
}

// NewSortRequest instantiates a new SortRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSortRequest() *SortRequest {
	this := SortRequest{}
	return &this
}

// NewSortRequestWithDefaults instantiates a new SortRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSortRequestWithDefaults() *SortRequest {
	this := SortRequest{}
	return &this
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *SortRequest) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SortRequest) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *SortRequest) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *SortRequest) SetSource(v string) {
	o.Source = &v
}

// GetRules returns the Rules field value if set, zero value otherwise.
func (o *SortRequest) GetRules() []SortRuleRequest {
	if o == nil || IsNil(o.Rules) {
		var ret []SortRuleRequest
		return ret
	}
	return o.Rules
}

// GetRulesOk returns a tuple with the Rules field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SortRequest) GetRulesOk() ([]SortRuleRequest, bool) {
	if o == nil || IsNil(o.Rules) {
		return nil, false
	}
	return o.Rules, true
}

// HasRules returns a boolean if a field has been set.
func (o *SortRequest) HasRules() bool {
	if o != nil && !IsNil(o.Rules) {
		return true
	}

	return false
}

// SetRules gets a reference to the given []SortRuleRequest and assigns it to the Rules field.
func (o *SortRequest) SetRules(v []SortRuleRequest) {
	o.Rules = v
}

func (o SortRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SortRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.Rules) {
		toSerialize["rules"] = o.Rules
	}
	return toSerialize, nil
}

type NullableSortRequest struct {
	value *SortRequest
	isSet bool
}

func (v NullableSortRequest) Get() *SortRequest {
	return v.value
}

func (v *NullableSortRequest) Set(val *SortRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSortRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSortRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSortRequest(val *SortRequest) *NullableSortRequest {
	return &NullableSortRequest{value: val, isSet: true}
}

func (v NullableSortRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSortRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
